Index: src/infrastructure.cpp
===================================================================
--- src/infrastructure.cpp	(revision 0)
+++ src/infrastructure.cpp	(revision 0)
@@ -0,0 +1,511 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file infrastructure.cpp Implementation of infrastructure sharing */
+
+#include "infrastructure_func.h"
+#include "command_func.h"
+#include "window_func.h"
+#include "depot_base.h"
+#include "train.h"
+#include "aircraft.h"
+#include "vehicle_func.h"
+#include "news_func.h"
+#include "strings_func.h"
+#include "yapf/yapf.h"
+#include "date_func.h"
+#include "gfx_func.h"
+#include "company_func.h"
+#include "station_base.h"
+#include "waypoint_base.h"
+
+#include "table/strings.h"
+
+extern DiagDirection TrainExitDir(Direction direction, TrackBits track);
+extern void ClearPathReservation(const Train *v, TileIndex tile, Trackdir track_dir);
+
+bool CompanySharingSettingsEntry::Equals(const CompanySharingSettingsEntry *o) const
+{
+	VehicleType vt;
+	FOR_ALL_SHARING_VEHTYPES(vt) {
+		if (this->IsSharingAllowed(vt) != o->IsSharingAllowed(vt) || this->GetSharingFee(vt) != o->GetSharingFee(vt)) return false;
+	}
+	return this->allowed_companies == o->allowed_companies;
+}
+
+byte CompanySharingSettingsEntry::Copy(const CompanySharingSettingsEntry *o)
+{
+	/* (x & y) != x returns true if any of the bits in x is not set in y.
+	 * i.e. if any company, permission, etc is removed */
+	byte changed_vehtypes = 0;
+	VehicleType vt;
+	FOR_ALL_SHARING_VEHTYPES(vt) {
+		if (this->IsSharingAllowed(vt) && !o->IsSharingAllowed(vt)) {
+			SetBit(changed_vehtypes, vt);
+		}
+	}
+	if ((this->allowed_companies & o->allowed_companies) != this->allowed_companies) changed_vehtypes = ALL_SHARING_VEHTYPES;
+
+	/* Copy the entire struct */
+	*this = *o;
+
+	return changed_vehtypes;
+}
+
+byte CompanySharingSettingsEntry::CopyFromGameSettings()
+{
+	/* Create a struct with the same settings as in the game settings,
+	 * then copy it to us using the normal Copy method. */
+	CompanySharingSettingsEntry game_settings;
+
+	game_settings.allowed_types = 0;
+	game_settings.SetSharingAllowed(VEH_TRAIN,    _settings_game.sharing.rail_sharing);
+	game_settings.SetSharingAllowed(VEH_ROAD,     _settings_game.sharing.road_sharing);
+	game_settings.SetSharingAllowed(VEH_SHIP,     _settings_game.sharing.water_sharing);
+	game_settings.SetSharingAllowed(VEH_AIRCRAFT, _settings_game.sharing.air_sharing);
+
+	game_settings.SetSharingFee(VEH_TRAIN,    _settings_game.sharing.rail_fee);
+	game_settings.SetSharingFee(VEH_ROAD,     _settings_game.sharing.road_fee);
+	game_settings.SetSharingFee(VEH_SHIP,     _settings_game.sharing.water_fee);
+	game_settings.SetSharingFee(VEH_AIRCRAFT, _settings_game.sharing.air_fee);
+
+	game_settings.allowed_companies = 0;
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		game_settings.SetCompanyAllowed(c->index, true);
+	}
+
+	return this->Copy(&game_settings);
+}
+
+/**
+ * Helper function for transferring sharing fees
+ * @param v The vehicle involved
+ * @param owner The owner of the infrastructure
+ * @param cost Amount to transfer as money fraction (shifted 8 bits to the left)
+ */
+static void PaySharingFee(Vehicle *v, Owner owner, Money cost)
+{
+	Company *c = Company::GetIfValid(v->owner);
+	assert(c != NULL);
+	if (_settings_game.sharing.payment_in_debt || (c->money - c->current_loan) >= (cost >> 8)) {
+		v->profit_this_year -= cost;
+		SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_SHARED_RUN, cost));
+		SubtractMoneyFromCompanyFract(owner, CommandCost(EXPENSES_SHARED_INC, -cost));
+	} else if (owner == _local_company && (c->sharing_insolvency_news_date + SHARING_NEWS_INTERVAL_INSOLVENCY) <= _date) {
+		AddSharingNewsItem(STR_NEWS_SHARING_UNABLE_TO_PAY, c);
+		c->sharing_insolvency_news_date = _date;
+	}
+}
+
+/**
+ * Pay the fee for spending a single tick inside a station.
+ * @param v The vehicle that is using the station.
+ * @param st The station that it uses.
+ */
+void PayStationSharingFee(Vehicle *v, const Station *st)
+{
+	if (v->owner == st->owner || st->owner == OWNER_NONE || v->type == VEH_TRAIN) return;
+	Money cost = GetSharingFee(st->owner, v->type);
+	PaySharingFee(v, st->owner, (cost << 8) / DAY_TICKS);
+}
+
+/**
+ * Pay the daily fee for trains on foreign tracks.
+ * @param v The vehicle to pay the fee for.
+ */
+void PayDailyTrackSharingFee(Train *v)
+{
+	Owner owner = GetTileOwner(v->tile);
+	if (owner == v->owner) return;
+	Money cost = GetSharingFee(owner, VEH_TRAIN);
+	cost = (cost << 8) * v->tcache.cached_total_length / 16; //cost is per 16 units = 1 tile
+	cost = cost * 12 / DAYS_IN_YEAR; //cost is per month, but we pay daily.
+	PaySharingFee(v, owner, cost);
+}
+
+/**
+ * Add a sharing-related news message to the news stack.
+ * @param string The message string to show.
+ * @param c Company this message is about.
+ * @param param Optional additional parameter to use for drawing the string.
+ */
+void AddSharingNewsItem(StringID string, Company *c, uint32 param)
+{
+	CompanyNewsInformation *cni = MallocT<CompanyNewsInformation>(1);
+	cni->FillData(c);
+
+	SetDParam(0, STR_NEWS_SHARING_TITLE);
+	SetDParam(1, string);
+	SetDParamStr(2, cni->company_name);
+	SetDParam(3, param);
+
+	AddCompanyNewsItem(STR_MESSAGE_NEWS_FORMAT, NS_COMPANY_SHARING, cni);
+}
+
+/**
+ * Change the sharing settings of a company.
+ * @see ModifySharingFlag
+ * @param tile unused
+ * @param flags operation to perform
+ * @param p1 bitstuffed elements regarding the variable to change:
+ * - p1 = (bit 0 -  7) What to change (boolean option, fee or allowed company)
+ * - p1 = (bit 8 - 15) The vehicle type or company to change it for.
+ * @param p2 value to change the aforementioned variable to
+ * @param text unused
+ * @return the cost of this operation or an error
+ */
+CommandCost CmdChangeSharingSetting(TileIndex tile, DoCommandFlag flags, uint32 p1, uint32 p2, const char *text)
+{
+	if (_settings_game.sharing.sharing_mode != SHARING_INDIVIDUAL) return CMD_ERROR;
+	byte index = GB(p1, 8, 8); //vehicle type or company id
+
+	Company *c = Company::GetIfValid(_current_company);
+	if (c == NULL) return CMD_ERROR;
+
+	ModifySharingFlag msf = (ModifySharingFlag)GB(p1, 0, 8);
+	switch (msf) {
+		case MODIFY_SHARING_OPTION:
+			if (index >= NUM_SHARING_VEHTYPES) return CMD_ERROR;
+			if (!!p2 == c->sharing_future.IsSharingAllowed((VehicleType)index)) return CMD_ERROR;
+			break;
+		case MODIFY_SHARING_FEE:
+			if (index >= NUM_SHARING_VEHTYPES) return CMD_ERROR;
+			if (p2 > MAX_SHARING_FEE || p2 == c->sharing_future.GetSharingFee((VehicleType)index)) return CMD_ERROR;
+			break;
+		case MODIFY_SHARING_COMPANIES:
+			if (!Company::IsValidID(index) || index == _current_company) return CMD_ERROR;
+			if (!!p2 == c->sharing_future.IsCompanyAllowed((CompanyID)index)) return CMD_ERROR;
+			break;
+		default: return CMD_ERROR;
+	}
+
+	if (flags & DC_EXEC) {
+		switch (msf) {
+			case MODIFY_SHARING_OPTION:    c->sharing_future.SetSharingAllowed((VehicleType)index, p2 != 0); break;
+			case MODIFY_SHARING_FEE:       c->sharing_future.SetSharingFee((VehicleType)index, p2);          break;
+			case MODIFY_SHARING_COMPANIES: c->sharing_future.SetCompanyAllowed((CompanyID)index, p2 != 0);   break;
+			default: NOT_REACHED();
+		}
+
+		/* Set the sharing delay, and copy the future settings to the current settings if needed */
+		if (c->sharing_future.Equals(&c->sharing_current)) {
+			c->sharing_delay = 0;
+		} else if (_settings_game.sharing.new_individual_delay == 0) {
+			assert(c->sharing_delay == 0);
+			ProcessSharingChanges();
+		} else {
+			c->sharing_delay = _settings_game.sharing.new_individual_delay;
+			if (_current_company != _local_company && c->sharing_setting_change_news_date + SHARING_NEWS_INTERVAL_SETTING_CHANGE <= _date) {
+				c->sharing_setting_change_news_date = _date;
+				AddSharingNewsItem(STR_NEWS_SHARING_CHANGE_ANNOUNCED, c, c->sharing_delay);
+			}
+		}
+		InvalidateWindowData(WC_SHARING_OPTIONS, _current_company);
+	}
+	return CommandCost();
+}
+
+/**
+ * Update all level crossings in front of a train.
+ * This has to be done before all other actions.
+ */
+static void UpdateAllCrossings()
+{
+	Train *v;
+	FOR_ALL_TRAINS(v) {
+		TileIndex crossing = v->tile + TileOffsByDiagDir(TrainExitDir(v->direction, v->track));
+		if (IsLevelCrossingTile(crossing)) UpdateLevelCrossing(crossing, false);
+	}
+}
+
+/**
+ * Sell a vehicle, no matter where it may be.
+ * Also make sure no artifacts are left, such as PBS paths
+ * @param v The vehicle to sell
+ */
+static void RemoveAndSellVehicle(Vehicle *v)
+{
+	static SmallVector<TileIndex, 4> crossing_tiles;
+
+	/* Crashed vehicles will remove themselves, no need for action */
+	if (v->vehstatus & VS_CRASHED) return;
+
+	if (v->type == VEH_TRAIN) {
+		/* Clear path reservation. This will not clear any reservation that has become invalid, we will do that later */
+		FreeTrainTrackReservation(Train::From(v));
+		for (const Train *u = Train::From(v); u != NULL; u = u->Next()) {
+			/* We cannot remove these reservations reliably,
+			 * since wormholes can contain more than one vehicle.
+			 * Therefore, we leave the reservation, it will be dealt with later. */
+			if (!IsTileType(u->tile, MP_TUNNELBRIDGE)) {
+				ClearPathReservation(u, u->tile, u->GetVehicleTrackdir());
+			}
+			if (IsLevelCrossingTile(u->tile) && !crossing_tiles.Contains(u->tile)) {
+				*crossing_tiles.Append() = u->tile;
+			}
+		}
+	}
+	SubtractMoneyFromCompanyFract(v->owner, CommandCost(EXPENSES_NEW_VEHICLES, -(v->value << 8)));
+	delete v;
+
+	for (uint i = 0; i < crossing_tiles.Length(); i++) {
+		UpdateLevelCrossing(crossing_tiles[i], false);
+	}
+	crossing_tiles.Clear();
+}
+
+
+/**
+ * Check the positions of all vehicles.
+ * If it is not in an allowed position,
+ * (e.g. it is in a depot when sharing of depots is disabled)
+ * then it is sold immediately.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ * @return true if any *trains* were removed.
+ */
+static bool CheckAllVehiclePositions(byte changed_vehtypes)
+{
+	bool sold_trains = false;
+	uint num_sold_local_vehicles = 0;
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() || (v->type == VEH_TRAIN && Train::From(v)->IsFreeWagon()))) continue;
+		if (!HasBit(changed_vehtypes, v->type)) continue;
+		switch (v->type) {
+			case VEH_TRAIN:
+				for (Vehicle *u = v; u != NULL; u = u->Next()) {
+					/* If any wagon is on a disallowed tile, sell the entire train */
+					if (!IsInfraUsageAllowed(u->tile, u)) {
+						if (v->owner == _local_company) num_sold_local_vehicles++;
+						sold_trains = true;
+						RemoveAndSellVehicle(v);
+						break;
+					}
+				}
+				break;
+			case VEH_ROAD:
+				for (Vehicle *u = v; u != NULL; u = u->Next()) {
+					/* Check all articulated parts */
+					if ((IsRoadDepotTile(u->tile) && !IsInfraUsageAllowed(u->tile, u)) ||
+						(IsStandardRoadStopTile(u->tile) && !IsInfraUsageAllowed(u->tile, u))) {
+							if (v->owner == _local_company) num_sold_local_vehicles++;
+							RemoveAndSellVehicle(v);
+							break;
+					}
+				}
+				break;
+			case VEH_SHIP:
+				if (IsShipDepotTile(v->tile) && v->IsStoppedInDepot() && !IsInfraUsageAllowed(v->tile, v)) {
+					if (v->owner == _local_company) num_sold_local_vehicles++;
+					RemoveAndSellVehicle(v);
+				}
+				break;
+			case VEH_AIRCRAFT: {
+				Aircraft *a = Aircraft::From(v);
+				if (a->state == FLYING) break;
+				if (Station::IsValidID(a->targetairport) &&
+					!IsInfraUsageAllowed(Station::Get(a->targetairport)->owner, v)) {
+						if (v->owner == _local_company) num_sold_local_vehicles++;
+						RemoveAndSellVehicle(v);
+				}
+				break;
+			}
+			default: break;
+		}
+	}
+	if (num_sold_local_vehicles > 0) {
+		SetDParam(0, num_sold_local_vehicles);
+		AddNewsItem(STR_NEWS_SHARING_SOLD_VEHICLES, NS_GENERAL);
+	}
+
+	return sold_trains;
+}
+
+/**
+ * Check whether an order has an allowed destination.
+ * I.e. it refers to a station/depot/waypoint the vehicle is allowed to visit.
+ * @param o The order to check
+ * @param v The vehicle this order belongs to.
+ * @return true if the order has an allowed destination.
+ */
+static bool OrderDestinationIsAllowed(const Order *o, const Vehicle *v)
+{
+	DestinationID dest = o->GetDestination();
+	switch (o->GetType()) {
+		case OT_GOTO_STATION:  return IsInfraUsageAllowed(Station::Get(dest)->owner, v);
+		case OT_GOTO_DEPOT:    return v->type == VEH_AIRCRAFT ? IsInfraUsageAllowed(Station::Get(dest)->owner, v) : IsInfraUsageAllowed(Depot::Get(dest)->xy, v);
+		case OT_GOTO_WAYPOINT: return IsInfraUsageAllowed(Waypoint::Get(dest)->owner, v);
+		default: return true;
+	}
+}
+
+/**
+ * Review the orders of all vehicles
+ * This makes sure they don't have any orders to destinations
+ * where they are not allowed to go.
+ * @param changed_vehtypes bitmask of vehicle types that were affected by a sharing setting change.
+ */
+static void ReviewAllVehicleOrders(byte changed_vehtypes)
+{
+	Vehicle *v;
+	FOR_ALL_VEHICLES(v) {
+		if (!(v->IsPrimaryVehicle() && HasBit(changed_vehtypes, v->type))) continue;
+
+		if (!OrderDestinationIsAllowed(&v->current_order, v)) {
+			v->current_order.MakeDummy();
+			SetWindowDirty(WC_VEHICLE_VIEW, v->index);
+		} else if (v->current_order.IsType(OT_LOADING)) {
+			if (!IsInfraUsageAllowed(Station::Get(v->last_station_visited)->owner, v)) {
+				v->LeaveStation();
+			}
+		}
+
+		if (v->FirstShared() != v) continue;
+
+		Order *o;
+		int id = -1;
+		FOR_VEHICLE_ORDERS(v, o) {
+			id++;
+			if (OrderDestinationIsAllowed(o, v)) continue;
+
+			o->MakeDummy();
+			for (const Vehicle *w = v->FirstShared(); w != NULL; w = w->NextShared()) {
+				/* In GUI, simulate by removing the order and adding it back */
+				InvalidateVehicleOrder(w, id | (INVALID_VEH_ORDER_ID << 8));
+				InvalidateVehicleOrder(w, (INVALID_VEH_ORDER_ID << 8) | id);
+			}
+		}
+	}
+}
+/**
+ * Helper proc for HasVehicleOnPos to determine whether there is a train on a certain track.
+ * @param v The vehicle that may be on this track
+ * @param track the track the train should be on.
+ * @return v if it is on this track, or null otherwise.
+ */
+static Vehicle *HasTrainOnTrackProc(Vehicle *v, void *track)
+{
+	if (v->type != VEH_TRAIN) return NULL;
+	Train *t = Train::From(v);
+	if (TrackBitsToTrack(t->track) == *(Track *)track || t->track == TRACK_BIT_WORMHOLE) {
+		return v;
+	}
+	return NULL;
+}
+
+/**
+ * Check the reservations of all tiles.
+ * If these to not seem to belong to a train or the train is not allowed to use them, unreserve them.
+ */
+static void CheckAllReservations()
+{
+	for (TileIndex tile = 0; tile < MapSize(); tile++) {
+		TrackBits bits = GetReservedTrackbits(tile);
+		while (bits != TRACK_BIT_NONE) {
+			Track track = RemoveFirstTrack(&bits);
+			/* Don't bother continuing if there is a vehicle on this tile */
+			if (HasVehicleOnPos(tile, &track, &HasTrainOnTrackProc)) continue;
+
+			Train *v = GetTrainForReservation(tile, track);
+			if (v == NULL) {
+				UnreserveRailTrack(tile, track);
+				/* make any PBS signal red */
+				Trackdir td = TrackToTrackdir(track);
+				if (HasPbsSignalOnTrackdir(tile, td)) SetSignalStateByTrackdir(tile, td, SIGNAL_STATE_RED);
+				if (HasPbsSignalOnTrackdir(tile, ReverseTrackdir(td))) SetSignalStateByTrackdir(tile, ReverseTrackdir(td), SIGNAL_STATE_RED);
+			}
+		}
+	}
+}
+
+/** Small struct to store a tile/track combination */
+struct SignalPosition {
+	TileIndex tile;  ///< Tile of the signal.
+	Track     track; ///< Track piece of the signal.
+	/** Create a new SignalPosition based on given tile and track piece */
+	SignalPosition(TileIndex _tile, Track _track) : tile(_tile), track(_track) {};
+};
+
+/**
+ * Update all signals on the map.
+ * Since whe do not know which ones are affected by the sharing change, we invalidate them all.
+ * Updating signals can only be done on a per-company basis.
+ * Therefore, we cache all signals into lists, one per company
+ * Then we update all signals in each list.
+ */
+static void UpdateBlockSignals()
+{
+	static SmallVector<SignalPosition, 256> signal_lists[MAX_COMPANIES];
+
+	for (TileIndex tile = 0; tile < MapSize(); tile++) {
+		if (IsTileType(tile, MP_RAILWAY) && HasSignals(tile)) {
+			TrackBits bits = GetTrackBits(tile);
+			do {
+				Track track = RemoveFirstTrack(&bits);
+				if (HasSignalOnTrack(tile, track)) {
+					*signal_lists[GetTileOwner(tile)].Append() = SignalPosition(tile, track);
+				}
+			} while (bits != TRACK_BIT_NONE);
+		}
+	}
+	for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+		for (uint i = 0; i < signal_lists[c].Length(); i++) {
+			AddTrackToSignalBuffer(signal_lists[c][i].tile, signal_lists[c][i].track, c);
+		}
+		UpdateSignalsInBuffer();
+		signal_lists[c].Reset();
+	}
+}
+
+/**
+ * Handle a change of sharing settings.
+ * This involves checking all orders,
+ * making sure all vehicles are not on disallowed territory,
+ * checking all PBS paths
+ * and updating signals.
+ * @param update_signals Force updating all signals on the map.
+ */
+void ProcessSharingChanges(bool update_signals)
+{
+	byte changed_vehtypes = 0;
+
+	/* Copy all future settings to the current settings, if applicable */
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay == 0 && !c->sharing_current.Equals(&c->sharing_future)) {
+			byte changes = c->sharing_current.Copy(&c->sharing_future);
+			if (c->index != _local_company) AddSharingNewsItem(STR_NEWS_SHARING_CHANGE_HAPPENED, c);
+			changed_vehtypes |= changes;
+		}
+	}
+	InvalidateWindowClassesData(WC_SHARING_OPTIONS);
+
+	/* No changes at all? abort */
+	if (changed_vehtypes == 0 && !update_signals) return;
+
+	/* Invalidate the entire cache */
+	YapfNotifyTrackLayoutChange(INVALID_TILE, INVALID_TRACK);
+
+	/* Almost any change in settings can causes changes in the level crossings.
+	 * So always review those. */
+	UpdateAllCrossings();
+
+	if (changed_vehtypes != 0) {
+		update_signals |= CheckAllVehiclePositions(changed_vehtypes);
+		ReviewAllVehicleOrders(changed_vehtypes);
+	}
+	if (HasBit(changed_vehtypes, VEH_TRAIN)) {
+		CheckAllReservations();
+	}
+	if (update_signals) {
+		UpdateBlockSignals();
+	}
+	MarkWholeScreenDirty();
+}
Index: src/economy.cpp
===================================================================
--- src/economy.cpp	(revision 18351)
+++ src/economy.cpp	(working copy)
@@ -46,6 +46,7 @@
 #include "waypoint_base.h"
 #include "economy_base.h"
 #include "core/pool_func.hpp"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -387,6 +388,47 @@
 		}
 	}
 
+	/* make the sharing settings the most permissive of the two companies */
+	if (new_owner != INVALID_OWNER) {
+		Company *c_new = Company::Get(new_owner);
+		CompanySharingSettingsEntry *old_settings = &Company::Get(old_owner)->sharing_current;
+		CompanySharingSettingsEntry *new_settings = &c_new->sharing_current;
+
+		VehicleType vt;
+		FOR_ALL_SHARING_VEHTYPES(vt) {
+			if (old_settings->IsSharingAllowed(vt)) new_settings->SetSharingAllowed(vt, true);
+			new_settings->SetSharingFee(vt, min(old_settings->GetSharingFee(vt), new_settings->GetSharingFee(vt)));
+		}
+		new_settings->allowed_companies |= old_settings->allowed_companies;
+
+		/* Make the future settings for the new company the same as the (new) current ones */
+		c_new->sharing_future.Copy(new_settings);
+		c_new->sharing_delay = 0;
+	} else {
+		/* Disable sharing for the old company
+		 * This will cause all vehicles on the old company's infrastructure
+		 * to be removed when ProcessSharingChanges is called */
+		Company *c_old = Company::Get(old_owner);
+		VehicleType vt;
+		FOR_ALL_SHARING_VEHTYPES(vt) {
+			c_old->sharing_future.SetSharingAllowed(vt, false);
+		}
+		c_old->sharing_delay = 0;
+		ProcessSharingChanges();
+	}
+
+	/* disallow the old company from all infrastructure */
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		c->sharing_current.SetCompanyAllowed(old_owner, false);
+		c->sharing_future.SetCompanyAllowed(old_owner, false);
+		/* Future and current settings could now be equal
+		 * In that case, set sharing_delay to 0 */
+		if (c->sharing_current.Equals(&c->sharing_future)) {
+			c->sharing_delay = 0;
+		}
+	}
+
 	/*  Change ownership of tiles */
 	{
 		TileIndex tile = 0;
@@ -699,6 +741,18 @@
 	}
 }
 
+/**
+ * Update the sharing settings of a all companies, if needed.
+ */
+static void CompaniesUpdateSharing()
+{
+	Company *c;
+	FOR_ALL_COMPANIES(c) {
+		if (c->sharing_delay > 0) --c->sharing_delay;
+	}
+	ProcessSharingChanges();
+}
+
 static void HandleEconomyFluctuations()
 {
 	if (_settings_game.difficulty.economy != 0) {
@@ -1414,6 +1468,7 @@
 		RecomputePrices();
 	}
 	CompaniesPayInterest();
+	CompaniesUpdateSharing();
 	/* Reset the _current_company flag */
 	_current_company = OWNER_NONE;
 	HandleEconomyFluctuations();
